import * as t from "io-ts";
import * as r from "italia-ts-commons/lib/requests";
import { BPDCitizen } from "./BPDCitizen";
import { ProblemJson } from "./ProblemJson";
import { BPDTransactionList } from "./BPDTransactionList";
import { PaymentMethodDetails } from "./PaymentMethodDetails";
import { AwardsList } from "./AwardsList";
/****************************************************************
 * GetBPDCitizen
 */
export declare type GetBPDCitizenT = r.IGetApiRequestType<{
    readonly Bearer: string;
    readonly "x-citizen-id": string;
}, "Authorization", never, r.IResponseType<200, BPDCitizen, never> | r.IResponseType<400, ProblemJson, never> | r.IResponseType<401, undefined, never> | r.IResponseType<403, ProblemJson, never> | r.IResponseType<404, ProblemJson, never> | r.IResponseType<429, undefined, never> | r.IResponseType<500, ProblemJson, never>>;
export declare const getBPDCitizenDefaultResponses: {
    200: t.ExactC<t.IntersectionC<[t.TypeC<{
        fiscal_code: t.Type<string & import("italia-ts-commons/lib/strings").IPatternStringTag<"^[A-Z]{6}[0-9LMNPQRSTUV]{2}[ABCDEHLMPRST][0-9LMNPQRSTUV]{2}[A-Z][0-9LMNPQRSTUV]{3}[A-Z]$">, string & import("italia-ts-commons/lib/strings").IPatternStringTag<"^[A-Z]{6}[0-9LMNPQRSTUV]{2}[ABCDEHLMPRST][0-9LMNPQRSTUV]{2}[A-Z][0-9LMNPQRSTUV]{3}[A-Z]$">, unknown>;
        timestamp_tc: t.StringC;
        payment_methods: t.ReadonlyArrayC<t.ExactC<t.IntersectionC<[t.TypeC<{
            payment_instrument_hpan: t.StringC;
            payment_instrument_status: t.Type<import("./PaymentMethodStatus").PaymentMethodStatusEnum, import("./PaymentMethodStatus").PaymentMethodStatusEnum, unknown>;
        }>, t.PartialC<{
            payment_instrument_insert_date: t.StringC;
            payment_instrument_insert_user: t.StringC;
            payment_instrument_update_date: t.StringC;
            payment_instrument_update_user: t.StringC;
            payment_instrument_enabled: t.BooleanC;
        }>]>>>;
    }>, t.PartialC<{
        payoff_instr: t.StringC;
        payoff_instr_type: t.StringC;
        insert_date: t.StringC;
        insert_user: t.StringC;
        update_date: t.StringC;
        update_user: t.StringC;
        enabled: t.BooleanC;
        checkiban_fiscal_code: t.StringC;
        checkiban_name: t.StringC;
        checkiban_surname: t.StringC;
        checkiban_status: t.StringC;
        cancellation: t.StringC;
    }>]>>;
    400: t.ExactC<t.IntersectionC<[t.TypeC<{}>, t.PartialC<{
        type: t.Type<string, any, unknown>;
        title: t.StringC;
        status: t.UnionC<[t.Type<number & import("italia-ts-commons/lib/numbers").IWithinRangeIntegerTag<100, 599>, number & import("italia-ts-commons/lib/numbers").IWithinRangeIntegerTag<100, 599>, unknown>, t.LiteralC<599>]>;
        detail: t.StringC;
        instance: t.StringC;
    }>]>>;
    401: t.UndefinedC;
    403: t.ExactC<t.IntersectionC<[t.TypeC<{}>, t.PartialC<{
        type: t.Type<string, any, unknown>;
        title: t.StringC;
        status: t.UnionC<[t.Type<number & import("italia-ts-commons/lib/numbers").IWithinRangeIntegerTag<100, 599>, number & import("italia-ts-commons/lib/numbers").IWithinRangeIntegerTag<100, 599>, unknown>, t.LiteralC<599>]>;
        detail: t.StringC;
        instance: t.StringC;
    }>]>>;
    404: t.ExactC<t.IntersectionC<[t.TypeC<{}>, t.PartialC<{
        type: t.Type<string, any, unknown>;
        title: t.StringC;
        status: t.UnionC<[t.Type<number & import("italia-ts-commons/lib/numbers").IWithinRangeIntegerTag<100, 599>, number & import("italia-ts-commons/lib/numbers").IWithinRangeIntegerTag<100, 599>, unknown>, t.LiteralC<599>]>;
        detail: t.StringC;
        instance: t.StringC;
    }>]>>;
    429: t.UndefinedC;
    500: t.ExactC<t.IntersectionC<[t.TypeC<{}>, t.PartialC<{
        type: t.Type<string, any, unknown>;
        title: t.StringC;
        status: t.UnionC<[t.Type<number & import("italia-ts-commons/lib/numbers").IWithinRangeIntegerTag<100, 599>, number & import("italia-ts-commons/lib/numbers").IWithinRangeIntegerTag<100, 599>, unknown>, t.LiteralC<599>]>;
        detail: t.StringC;
        instance: t.StringC;
    }>]>>;
};
export declare type GetBPDCitizenResponsesT<A0 = BPDCitizen, C0 = BPDCitizen, A1 = ProblemJson, C1 = ProblemJson, A2 = undefined, C2 = undefined, A3 = ProblemJson, C3 = ProblemJson, A4 = ProblemJson, C4 = ProblemJson, A5 = undefined, C5 = undefined, A6 = ProblemJson, C6 = ProblemJson> = {
    200: t.Type<A0, C0>;
    400: t.Type<A1, C1>;
    401: t.Type<A2, C2>;
    403: t.Type<A3, C3>;
    404: t.Type<A4, C4>;
    429: t.Type<A5, C5>;
    500: t.Type<A6, C6>;
};
export declare function GetBPDCitizenDecoder<A0 = BPDCitizen, C0 = BPDCitizen, A1 = ProblemJson, C1 = ProblemJson, A2 = undefined, C2 = undefined, A3 = ProblemJson, C3 = ProblemJson, A4 = ProblemJson, C4 = ProblemJson, A5 = undefined, C5 = undefined, A6 = ProblemJson, C6 = ProblemJson>(overrideTypes?: Partial<GetBPDCitizenResponsesT<A0, C0, A1, C1, A2, C2, A3, C3, A4, C4, A5, C5, A6, C6>> | t.Type<A0, C0> | undefined): r.ResponseDecoder<r.IResponseType<200, A0, never> | r.IResponseType<400, A1, never> | r.IResponseType<401, A2, never> | r.IResponseType<403, A3, never> | r.IResponseType<404, A4, never> | r.IResponseType<429, A5, never> | r.IResponseType<500, A6, never>>;
export declare const GetBPDCitizenDefaultDecoder: () => r.ResponseDecoder<r.IResponseType<401, undefined, never> | r.IResponseType<429, undefined, never> | r.IResponseType<200, {
    fiscal_code: string & import("italia-ts-commons/lib/strings").IPatternStringTag<"^[A-Z]{6}[0-9LMNPQRSTUV]{2}[ABCDEHLMPRST][0-9LMNPQRSTUV]{2}[A-Z][0-9LMNPQRSTUV]{3}[A-Z]$">;
    timestamp_tc: string;
    payment_methods: readonly ({
        payment_instrument_hpan: string;
        payment_instrument_status: import("./PaymentMethodStatus").PaymentMethodStatusEnum;
    } & {
        payment_instrument_insert_date?: string | undefined;
        payment_instrument_insert_user?: string | undefined;
        payment_instrument_update_date?: string | undefined;
        payment_instrument_update_user?: string | undefined;
        payment_instrument_enabled?: boolean | undefined;
    })[];
} & {
    payoff_instr?: string | undefined;
    payoff_instr_type?: string | undefined;
    insert_date?: string | undefined;
    insert_user?: string | undefined;
    update_date?: string | undefined;
    update_user?: string | undefined;
    enabled?: boolean | undefined;
    checkiban_fiscal_code?: string | undefined;
    checkiban_name?: string | undefined;
    checkiban_surname?: string | undefined;
    checkiban_status?: string | undefined;
    cancellation?: string | undefined;
}, never> | r.IResponseType<400, {} & {
    type?: string | undefined;
    title?: string | undefined;
    status?: 599 | (number & import("italia-ts-commons/lib/numbers").IWithinRangeIntegerTag<100, 599>) | undefined;
    detail?: string | undefined;
    instance?: string | undefined;
}, never> | r.IResponseType<403, {} & {
    type?: string | undefined;
    title?: string | undefined;
    status?: 599 | (number & import("italia-ts-commons/lib/numbers").IWithinRangeIntegerTag<100, 599>) | undefined;
    detail?: string | undefined;
    instance?: string | undefined;
}, never> | r.IResponseType<404, {} & {
    type?: string | undefined;
    title?: string | undefined;
    status?: 599 | (number & import("italia-ts-commons/lib/numbers").IWithinRangeIntegerTag<100, 599>) | undefined;
    detail?: string | undefined;
    instance?: string | undefined;
}, never> | r.IResponseType<500, {} & {
    type?: string | undefined;
    title?: string | undefined;
    status?: 599 | (number & import("italia-ts-commons/lib/numbers").IWithinRangeIntegerTag<100, 599>) | undefined;
    detail?: string | undefined;
    instance?: string | undefined;
}, never>>;
/****************************************************************
 * GetBPDTransactions
 */
export declare type GetBPDTransactionsT = r.IGetApiRequestType<{
    readonly Bearer: string;
    readonly "x-citizen-id": string;
}, "Authorization", never, r.IResponseType<200, BPDTransactionList, never> | r.IResponseType<400, ProblemJson, never> | r.IResponseType<401, undefined, never> | r.IResponseType<403, ProblemJson, never> | r.IResponseType<429, undefined, never> | r.IResponseType<500, ProblemJson, never>>;
export declare const getBPDTransactionsDefaultResponses: {
    200: t.ExactC<t.IntersectionC<[t.TypeC<{
        transactions: t.ReadonlyArrayC<t.ExactC<t.IntersectionC<[t.TypeC<{
            hpan: t.StringC;
            trx_timestamp: t.StringC;
            acquirer: t.StringC;
            id_trx_acquirer: t.StringC;
        }>, t.PartialC<{
            acquirer_id: t.StringC;
            acquirer_descr: t.Type<import("./BPDTransaction").Acquirer_descrEnum, import("./BPDTransaction").Acquirer_descrEnum, unknown>;
            id_trx_issuer: t.StringC;
            operation_type: t.StringC;
            operation_type_descr: t.Type<import("./BPDTransaction").Operation_type_descrEnum, import("./BPDTransaction").Operation_type_descrEnum, unknown>;
            circuit_type: t.StringC;
            circuit_type_descr: t.Type<import("./BPDTransaction").Circuit_type_descrEnum, import("./BPDTransaction").Circuit_type_descrEnum, unknown>;
            amount: t.NumberC;
            amount_currency: t.StringC;
            amount_currency_descr: t.StringC;
            score: t.NumberC;
            award_period_id: t.NumberC;
            merchant_id: t.StringC;
            correlation_id: t.StringC;
            bin: t.StringC;
            terminal_id: t.StringC;
            enabled: t.BooleanC;
            elab_ranking: t.BooleanC;
            insert_date: t.StringC;
            insert_user: t.StringC;
            update_date: t.StringC;
            update_user: t.StringC;
        }>]>>>;
    }>, t.PartialC<{}>]>>;
    400: t.ExactC<t.IntersectionC<[t.TypeC<{}>, t.PartialC<{
        type: t.Type<string, any, unknown>;
        title: t.StringC;
        status: t.UnionC<[t.Type<number & import("italia-ts-commons/lib/numbers").IWithinRangeIntegerTag<100, 599>, number & import("italia-ts-commons/lib/numbers").IWithinRangeIntegerTag<100, 599>, unknown>, t.LiteralC<599>]>;
        detail: t.StringC;
        instance: t.StringC;
    }>]>>;
    401: t.UndefinedC;
    403: t.ExactC<t.IntersectionC<[t.TypeC<{}>, t.PartialC<{
        type: t.Type<string, any, unknown>;
        title: t.StringC;
        status: t.UnionC<[t.Type<number & import("italia-ts-commons/lib/numbers").IWithinRangeIntegerTag<100, 599>, number & import("italia-ts-commons/lib/numbers").IWithinRangeIntegerTag<100, 599>, unknown>, t.LiteralC<599>]>;
        detail: t.StringC;
        instance: t.StringC;
    }>]>>;
    429: t.UndefinedC;
    500: t.ExactC<t.IntersectionC<[t.TypeC<{}>, t.PartialC<{
        type: t.Type<string, any, unknown>;
        title: t.StringC;
        status: t.UnionC<[t.Type<number & import("italia-ts-commons/lib/numbers").IWithinRangeIntegerTag<100, 599>, number & import("italia-ts-commons/lib/numbers").IWithinRangeIntegerTag<100, 599>, unknown>, t.LiteralC<599>]>;
        detail: t.StringC;
        instance: t.StringC;
    }>]>>;
};
export declare type GetBPDTransactionsResponsesT<A0 = BPDTransactionList, C0 = BPDTransactionList, A1 = ProblemJson, C1 = ProblemJson, A2 = undefined, C2 = undefined, A3 = ProblemJson, C3 = ProblemJson, A4 = undefined, C4 = undefined, A5 = ProblemJson, C5 = ProblemJson> = {
    200: t.Type<A0, C0>;
    400: t.Type<A1, C1>;
    401: t.Type<A2, C2>;
    403: t.Type<A3, C3>;
    429: t.Type<A4, C4>;
    500: t.Type<A5, C5>;
};
export declare function GetBPDTransactionsDecoder<A0 = BPDTransactionList, C0 = BPDTransactionList, A1 = ProblemJson, C1 = ProblemJson, A2 = undefined, C2 = undefined, A3 = ProblemJson, C3 = ProblemJson, A4 = undefined, C4 = undefined, A5 = ProblemJson, C5 = ProblemJson>(overrideTypes?: Partial<GetBPDTransactionsResponsesT<A0, C0, A1, C1, A2, C2, A3, C3, A4, C4, A5, C5>> | t.Type<A0, C0> | undefined): r.ResponseDecoder<r.IResponseType<200, A0, never> | r.IResponseType<400, A1, never> | r.IResponseType<401, A2, never> | r.IResponseType<403, A3, never> | r.IResponseType<429, A4, never> | r.IResponseType<500, A5, never>>;
export declare const GetBPDTransactionsDefaultDecoder: () => r.ResponseDecoder<r.IResponseType<401, undefined, never> | r.IResponseType<429, undefined, never> | r.IResponseType<400, {} & {
    type?: string | undefined;
    title?: string | undefined;
    status?: 599 | (number & import("italia-ts-commons/lib/numbers").IWithinRangeIntegerTag<100, 599>) | undefined;
    detail?: string | undefined;
    instance?: string | undefined;
}, never> | r.IResponseType<403, {} & {
    type?: string | undefined;
    title?: string | undefined;
    status?: 599 | (number & import("italia-ts-commons/lib/numbers").IWithinRangeIntegerTag<100, 599>) | undefined;
    detail?: string | undefined;
    instance?: string | undefined;
}, never> | r.IResponseType<500, {} & {
    type?: string | undefined;
    title?: string | undefined;
    status?: 599 | (number & import("italia-ts-commons/lib/numbers").IWithinRangeIntegerTag<100, 599>) | undefined;
    detail?: string | undefined;
    instance?: string | undefined;
}, never> | r.IResponseType<200, {
    transactions: readonly ({
        hpan: string;
        trx_timestamp: string;
        acquirer: string;
        id_trx_acquirer: string;
    } & {
        acquirer_id?: string | undefined;
        acquirer_descr?: import("./BPDTransaction").Acquirer_descrEnum | undefined;
        id_trx_issuer?: string | undefined;
        operation_type?: string | undefined;
        operation_type_descr?: import("./BPDTransaction").Operation_type_descrEnum | undefined;
        circuit_type?: string | undefined;
        circuit_type_descr?: import("./BPDTransaction").Circuit_type_descrEnum | undefined;
        amount?: number | undefined;
        amount_currency?: string | undefined;
        amount_currency_descr?: string | undefined;
        score?: number | undefined;
        award_period_id?: number | undefined;
        merchant_id?: string | undefined;
        correlation_id?: string | undefined;
        bin?: string | undefined;
        terminal_id?: string | undefined;
        enabled?: boolean | undefined;
        elab_ranking?: boolean | undefined;
        insert_date?: string | undefined;
        insert_user?: string | undefined;
        update_date?: string | undefined;
        update_user?: string | undefined;
    })[];
} & {}, never>>;
/****************************************************************
 * GetBPDPaymentInstrument
 */
export declare type GetBPDPaymentInstrumentT = r.IGetApiRequestType<{
    readonly Bearer: string;
    readonly "x-citizen-id": string;
    readonly hpan: string;
}, "Authorization", never, r.IResponseType<200, PaymentMethodDetails, never> | r.IResponseType<400, ProblemJson, never> | r.IResponseType<401, undefined, never> | r.IResponseType<403, ProblemJson, never> | r.IResponseType<404, ProblemJson, never> | r.IResponseType<500, ProblemJson, never>>;
export declare const getBPDPaymentInstrumentDefaultResponses: {
    200: t.ExactC<t.IntersectionC<[t.TypeC<{
        fiscal_code: t.Type<string & import("italia-ts-commons/lib/strings").IPatternStringTag<"^[A-Z]{6}[0-9LMNPQRSTUV]{2}[ABCDEHLMPRST][0-9LMNPQRSTUV]{2}[A-Z][0-9LMNPQRSTUV]{3}[A-Z]$">, string & import("italia-ts-commons/lib/strings").IPatternStringTag<"^[A-Z]{6}[0-9LMNPQRSTUV]{2}[ABCDEHLMPRST][0-9LMNPQRSTUV]{2}[A-Z][0-9LMNPQRSTUV]{3}[A-Z]$">, unknown>;
        hpan: t.StringC;
        enabled: t.BooleanC;
        activation_periods: t.ReadonlyArrayC<t.ExactC<t.IntersectionC<[t.TypeC<{
            enrollment: t.StringC;
            status: t.Type<import("./PaymentMethodStatus").PaymentMethodStatusEnum, import("./PaymentMethodStatus").PaymentMethodStatusEnum, unknown>;
        }>, t.PartialC<{
            cancellation: t.StringC;
            hist_insert_date: t.StringC;
            hist_insert_user: t.StringC;
            hist_update_date: t.StringC;
            hist_update_user: t.StringC;
        }>]>>>;
    }>, t.PartialC<{
        channel: t.StringC;
        channel_descr: t.Type<import("./PaymentMethodDetails").Channel_descrEnum, import("./PaymentMethodDetails").Channel_descrEnum, unknown>;
        update_date: t.StringC;
        insert_date: t.StringC;
        update_user: t.StringC;
        insert_user: t.StringC;
    }>]>>;
    400: t.ExactC<t.IntersectionC<[t.TypeC<{}>, t.PartialC<{
        type: t.Type<string, any, unknown>;
        title: t.StringC;
        status: t.UnionC<[t.Type<number & import("italia-ts-commons/lib/numbers").IWithinRangeIntegerTag<100, 599>, number & import("italia-ts-commons/lib/numbers").IWithinRangeIntegerTag<100, 599>, unknown>, t.LiteralC<599>]>;
        detail: t.StringC;
        instance: t.StringC;
    }>]>>;
    401: t.UndefinedC;
    403: t.ExactC<t.IntersectionC<[t.TypeC<{}>, t.PartialC<{
        type: t.Type<string, any, unknown>;
        title: t.StringC;
        status: t.UnionC<[t.Type<number & import("italia-ts-commons/lib/numbers").IWithinRangeIntegerTag<100, 599>, number & import("italia-ts-commons/lib/numbers").IWithinRangeIntegerTag<100, 599>, unknown>, t.LiteralC<599>]>;
        detail: t.StringC;
        instance: t.StringC;
    }>]>>;
    404: t.ExactC<t.IntersectionC<[t.TypeC<{}>, t.PartialC<{
        type: t.Type<string, any, unknown>;
        title: t.StringC;
        status: t.UnionC<[t.Type<number & import("italia-ts-commons/lib/numbers").IWithinRangeIntegerTag<100, 599>, number & import("italia-ts-commons/lib/numbers").IWithinRangeIntegerTag<100, 599>, unknown>, t.LiteralC<599>]>;
        detail: t.StringC;
        instance: t.StringC;
    }>]>>;
    500: t.ExactC<t.IntersectionC<[t.TypeC<{}>, t.PartialC<{
        type: t.Type<string, any, unknown>;
        title: t.StringC;
        status: t.UnionC<[t.Type<number & import("italia-ts-commons/lib/numbers").IWithinRangeIntegerTag<100, 599>, number & import("italia-ts-commons/lib/numbers").IWithinRangeIntegerTag<100, 599>, unknown>, t.LiteralC<599>]>;
        detail: t.StringC;
        instance: t.StringC;
    }>]>>;
};
export declare type GetBPDPaymentInstrumentResponsesT<A0 = PaymentMethodDetails, C0 = PaymentMethodDetails, A1 = ProblemJson, C1 = ProblemJson, A2 = undefined, C2 = undefined, A3 = ProblemJson, C3 = ProblemJson, A4 = ProblemJson, C4 = ProblemJson, A5 = ProblemJson, C5 = ProblemJson> = {
    200: t.Type<A0, C0>;
    400: t.Type<A1, C1>;
    401: t.Type<A2, C2>;
    403: t.Type<A3, C3>;
    404: t.Type<A4, C4>;
    500: t.Type<A5, C5>;
};
export declare function GetBPDPaymentInstrumentDecoder<A0 = PaymentMethodDetails, C0 = PaymentMethodDetails, A1 = ProblemJson, C1 = ProblemJson, A2 = undefined, C2 = undefined, A3 = ProblemJson, C3 = ProblemJson, A4 = ProblemJson, C4 = ProblemJson, A5 = ProblemJson, C5 = ProblemJson>(overrideTypes?: Partial<GetBPDPaymentInstrumentResponsesT<A0, C0, A1, C1, A2, C2, A3, C3, A4, C4, A5, C5>> | t.Type<A0, C0> | undefined): r.ResponseDecoder<r.IResponseType<200, A0, never> | r.IResponseType<400, A1, never> | r.IResponseType<401, A2, never> | r.IResponseType<403, A3, never> | r.IResponseType<404, A4, never> | r.IResponseType<500, A5, never>>;
export declare const GetBPDPaymentInstrumentDefaultDecoder: () => r.ResponseDecoder<r.IResponseType<401, undefined, never> | r.IResponseType<400, {} & {
    type?: string | undefined;
    title?: string | undefined;
    status?: 599 | (number & import("italia-ts-commons/lib/numbers").IWithinRangeIntegerTag<100, 599>) | undefined;
    detail?: string | undefined;
    instance?: string | undefined;
}, never> | r.IResponseType<403, {} & {
    type?: string | undefined;
    title?: string | undefined;
    status?: 599 | (number & import("italia-ts-commons/lib/numbers").IWithinRangeIntegerTag<100, 599>) | undefined;
    detail?: string | undefined;
    instance?: string | undefined;
}, never> | r.IResponseType<404, {} & {
    type?: string | undefined;
    title?: string | undefined;
    status?: 599 | (number & import("italia-ts-commons/lib/numbers").IWithinRangeIntegerTag<100, 599>) | undefined;
    detail?: string | undefined;
    instance?: string | undefined;
}, never> | r.IResponseType<500, {} & {
    type?: string | undefined;
    title?: string | undefined;
    status?: 599 | (number & import("italia-ts-commons/lib/numbers").IWithinRangeIntegerTag<100, 599>) | undefined;
    detail?: string | undefined;
    instance?: string | undefined;
}, never> | r.IResponseType<200, {
    fiscal_code: string & import("italia-ts-commons/lib/strings").IPatternStringTag<"^[A-Z]{6}[0-9LMNPQRSTUV]{2}[ABCDEHLMPRST][0-9LMNPQRSTUV]{2}[A-Z][0-9LMNPQRSTUV]{3}[A-Z]$">;
    hpan: string;
    enabled: boolean;
    activation_periods: readonly ({
        enrollment: string;
        status: import("./PaymentMethodStatus").PaymentMethodStatusEnum;
    } & {
        cancellation?: string | undefined;
        hist_insert_date?: string | undefined;
        hist_insert_user?: string | undefined;
        hist_update_date?: string | undefined;
        hist_update_user?: string | undefined;
    })[];
} & {
    channel?: string | undefined;
    channel_descr?: import("./PaymentMethodDetails").Channel_descrEnum | undefined;
    update_date?: string | undefined;
    insert_date?: string | undefined;
    update_user?: string | undefined;
    insert_user?: string | undefined;
}, never>>;
/****************************************************************
 * GetBPDAwards
 */
export declare type GetBPDAwardsT = r.IGetApiRequestType<{
    readonly Bearer: string;
    readonly "x-citizen-id": string;
}, "Authorization", never, r.IResponseType<200, AwardsList, never> | r.IResponseType<400, ProblemJson, never> | r.IResponseType<401, undefined, never> | r.IResponseType<403, ProblemJson, never> | r.IResponseType<404, ProblemJson, never> | r.IResponseType<429, undefined, never> | r.IResponseType<500, ProblemJson, never>>;
export declare const getBPDAwardsDefaultResponses: {
    200: t.ExactC<t.IntersectionC<[t.TypeC<{
        fiscal_code: t.Type<string & import("italia-ts-commons/lib/strings").IPatternStringTag<"^[A-Z]{6}[0-9LMNPQRSTUV]{2}[ABCDEHLMPRST][0-9LMNPQRSTUV]{2}[A-Z][0-9LMNPQRSTUV]{3}[A-Z]$">, string & import("italia-ts-commons/lib/strings").IPatternStringTag<"^[A-Z]{6}[0-9LMNPQRSTUV]{2}[ABCDEHLMPRST][0-9LMNPQRSTUV]{2}[A-Z][0-9LMNPQRSTUV]{3}[A-Z]$">, unknown>;
        awards: t.ReadonlyArrayC<t.ExactC<t.IntersectionC<[t.TypeC<{
            award_period_id: t.NumberC;
            award_period_start: t.StringC;
            award_period_end: t.StringC;
            award_period_grace_period: t.NumberC;
            award_period_amount_max: t.NumberC;
            award_period_trx_volume_min: t.NumberC;
            award_period_trx_eval_max: t.NumberC;
            award_period_ranking_min: t.NumberC;
            award_period_trx_cashback_max: t.NumberC;
            award_period_cashback_max: t.NumberC;
            award_period_cashback_perc: t.NumberC;
        }>, t.PartialC<{
            award_winner_id: t.NumberC;
            award_winner_period_id: t.NumberC;
            award_winner_payoff_instr: t.StringC;
            award_winner_amount: t.NumberC;
            award_winner_period_start: t.StringC;
            award_winner_period_end: t.StringC;
            award_winner_jackpot: t.NumberC;
            award_winner_cashback: t.NumberC;
            award_winner_typology: t.StringC;
            award_winner_account_holder_cf: t.StringC;
            award_winner_account_holder_name: t.StringC;
            award_winner_account_holder_surname: t.StringC;
            award_winner_check_instr_status: t.StringC;
            award_winner_insert_date: t.StringC;
            award_winner_insert_user: t.StringC;
            award_winner_update_date: t.StringC;
            award_winner_update_user: t.StringC;
            award_winner_enabled: t.BooleanC;
            citizen_ranking_period_id: t.NumberC;
            citizen_ranking_cashback: t.NumberC;
            citizen_ranking_transaction: t.NumberC;
            citizen_ranking_ranking: t.NumberC;
            citizen_ranking_ranking_date: t.StringC;
            citizen_ranking_insert_date: t.StringC;
            citizen_ranking_insert_user: t.StringC;
            citizen_ranking_update_date: t.StringC;
            citizen_ranking_update_user: t.StringC;
            citizen_ranking_enabled: t.BooleanC;
            award_period_insert_date: t.StringC;
            award_period_insert_user: t.StringC;
            award_period_update_date: t.StringC;
            award_period_update_user: t.StringC;
            award_period_enabled: t.BooleanC;
        }>]>>>;
    }>, t.PartialC<{}>]>>;
    400: t.ExactC<t.IntersectionC<[t.TypeC<{}>, t.PartialC<{
        type: t.Type<string, any, unknown>;
        title: t.StringC;
        status: t.UnionC<[t.Type<number & import("italia-ts-commons/lib/numbers").IWithinRangeIntegerTag<100, 599>, number & import("italia-ts-commons/lib/numbers").IWithinRangeIntegerTag<100, 599>, unknown>, t.LiteralC<599>]>;
        detail: t.StringC;
        instance: t.StringC;
    }>]>>;
    401: t.UndefinedC;
    403: t.ExactC<t.IntersectionC<[t.TypeC<{}>, t.PartialC<{
        type: t.Type<string, any, unknown>;
        title: t.StringC;
        status: t.UnionC<[t.Type<number & import("italia-ts-commons/lib/numbers").IWithinRangeIntegerTag<100, 599>, number & import("italia-ts-commons/lib/numbers").IWithinRangeIntegerTag<100, 599>, unknown>, t.LiteralC<599>]>;
        detail: t.StringC;
        instance: t.StringC;
    }>]>>;
    404: t.ExactC<t.IntersectionC<[t.TypeC<{}>, t.PartialC<{
        type: t.Type<string, any, unknown>;
        title: t.StringC;
        status: t.UnionC<[t.Type<number & import("italia-ts-commons/lib/numbers").IWithinRangeIntegerTag<100, 599>, number & import("italia-ts-commons/lib/numbers").IWithinRangeIntegerTag<100, 599>, unknown>, t.LiteralC<599>]>;
        detail: t.StringC;
        instance: t.StringC;
    }>]>>;
    429: t.UndefinedC;
    500: t.ExactC<t.IntersectionC<[t.TypeC<{}>, t.PartialC<{
        type: t.Type<string, any, unknown>;
        title: t.StringC;
        status: t.UnionC<[t.Type<number & import("italia-ts-commons/lib/numbers").IWithinRangeIntegerTag<100, 599>, number & import("italia-ts-commons/lib/numbers").IWithinRangeIntegerTag<100, 599>, unknown>, t.LiteralC<599>]>;
        detail: t.StringC;
        instance: t.StringC;
    }>]>>;
};
export declare type GetBPDAwardsResponsesT<A0 = AwardsList, C0 = AwardsList, A1 = ProblemJson, C1 = ProblemJson, A2 = undefined, C2 = undefined, A3 = ProblemJson, C3 = ProblemJson, A4 = ProblemJson, C4 = ProblemJson, A5 = undefined, C5 = undefined, A6 = ProblemJson, C6 = ProblemJson> = {
    200: t.Type<A0, C0>;
    400: t.Type<A1, C1>;
    401: t.Type<A2, C2>;
    403: t.Type<A3, C3>;
    404: t.Type<A4, C4>;
    429: t.Type<A5, C5>;
    500: t.Type<A6, C6>;
};
export declare function GetBPDAwardsDecoder<A0 = AwardsList, C0 = AwardsList, A1 = ProblemJson, C1 = ProblemJson, A2 = undefined, C2 = undefined, A3 = ProblemJson, C3 = ProblemJson, A4 = ProblemJson, C4 = ProblemJson, A5 = undefined, C5 = undefined, A6 = ProblemJson, C6 = ProblemJson>(overrideTypes?: Partial<GetBPDAwardsResponsesT<A0, C0, A1, C1, A2, C2, A3, C3, A4, C4, A5, C5, A6, C6>> | t.Type<A0, C0> | undefined): r.ResponseDecoder<r.IResponseType<200, A0, never> | r.IResponseType<400, A1, never> | r.IResponseType<401, A2, never> | r.IResponseType<403, A3, never> | r.IResponseType<404, A4, never> | r.IResponseType<429, A5, never> | r.IResponseType<500, A6, never>>;
export declare const GetBPDAwardsDefaultDecoder: () => r.ResponseDecoder<r.IResponseType<401, undefined, never> | r.IResponseType<429, undefined, never> | r.IResponseType<400, {} & {
    type?: string | undefined;
    title?: string | undefined;
    status?: 599 | (number & import("italia-ts-commons/lib/numbers").IWithinRangeIntegerTag<100, 599>) | undefined;
    detail?: string | undefined;
    instance?: string | undefined;
}, never> | r.IResponseType<403, {} & {
    type?: string | undefined;
    title?: string | undefined;
    status?: 599 | (number & import("italia-ts-commons/lib/numbers").IWithinRangeIntegerTag<100, 599>) | undefined;
    detail?: string | undefined;
    instance?: string | undefined;
}, never> | r.IResponseType<404, {} & {
    type?: string | undefined;
    title?: string | undefined;
    status?: 599 | (number & import("italia-ts-commons/lib/numbers").IWithinRangeIntegerTag<100, 599>) | undefined;
    detail?: string | undefined;
    instance?: string | undefined;
}, never> | r.IResponseType<500, {} & {
    type?: string | undefined;
    title?: string | undefined;
    status?: 599 | (number & import("italia-ts-commons/lib/numbers").IWithinRangeIntegerTag<100, 599>) | undefined;
    detail?: string | undefined;
    instance?: string | undefined;
}, never> | r.IResponseType<200, {
    fiscal_code: string & import("italia-ts-commons/lib/strings").IPatternStringTag<"^[A-Z]{6}[0-9LMNPQRSTUV]{2}[ABCDEHLMPRST][0-9LMNPQRSTUV]{2}[A-Z][0-9LMNPQRSTUV]{3}[A-Z]$">;
    awards: readonly ({
        award_period_id: number;
        award_period_start: string;
        award_period_end: string;
        award_period_grace_period: number;
        award_period_amount_max: number;
        award_period_trx_volume_min: number;
        award_period_trx_eval_max: number;
        award_period_ranking_min: number;
        award_period_trx_cashback_max: number;
        award_period_cashback_max: number;
        award_period_cashback_perc: number;
    } & {
        award_winner_id?: number | undefined;
        award_winner_period_id?: number | undefined;
        award_winner_payoff_instr?: string | undefined;
        award_winner_amount?: number | undefined;
        award_winner_period_start?: string | undefined;
        award_winner_period_end?: string | undefined;
        award_winner_jackpot?: number | undefined;
        award_winner_cashback?: number | undefined;
        award_winner_typology?: string | undefined;
        award_winner_account_holder_cf?: string | undefined;
        award_winner_account_holder_name?: string | undefined;
        award_winner_account_holder_surname?: string | undefined;
        award_winner_check_instr_status?: string | undefined;
        award_winner_insert_date?: string | undefined;
        award_winner_insert_user?: string | undefined;
        award_winner_update_date?: string | undefined;
        award_winner_update_user?: string | undefined;
        award_winner_enabled?: boolean | undefined;
        citizen_ranking_period_id?: number | undefined;
        citizen_ranking_cashback?: number | undefined;
        citizen_ranking_transaction?: number | undefined;
        citizen_ranking_ranking?: number | undefined;
        citizen_ranking_ranking_date?: string | undefined;
        citizen_ranking_insert_date?: string | undefined;
        citizen_ranking_insert_user?: string | undefined;
        citizen_ranking_update_date?: string | undefined;
        citizen_ranking_update_user?: string | undefined;
        citizen_ranking_enabled?: boolean | undefined;
        award_period_insert_date?: string | undefined;
        award_period_insert_user?: string | undefined;
        award_period_update_date?: string | undefined;
        award_period_update_user?: string | undefined;
        award_period_enabled?: boolean | undefined;
    })[];
} & {}, never>>;
